#
#
#	This could be done in in-line asm, but I don't want any
#	extra code to execute because I am using only the locking
#	provided by manipulation of the stack-pointer (no spin-locks).
#
#
.section	.data
old_sp:		.long	0
.section	.text

set_new_stack:
	popl	%ecx			# Return address
	popl	%eax			# Address of new stack 
	movl	%esp, (old_sp)		# Save old stack-pointer
	andl	$0xfffffff0, %eax	# Align for worse-case
	movl	%eax, %esp		# Load stack
	pushl	%eax			# Dummy param
	pushl	%ecx			# Return address
	ret
.size	set_new_stack,.-set_new_stack
.type	set_new_stack,@function
.global	set_new_stack


restore_stack:
	popl	%ecx			# Return address
	popl	%eax			# Address to throw away 
	movl	(old_sp), %esp		# Load stack
	pushl	%eax			# Dummy param
	pushl	%ecx			# Return address
	ret
.size	restore_stack,.-restore_stack
.type	restore_stack,@function
.global	restore_stack

.end

